/* ***** BEGIN LICENSE BLOCK *****
* Version: MPL 1.1/GPL 2.0/LGPL 2.1
*
* The contents of this file are subject to the Mozilla Public License Version
* 1.1 (the "License"); you may not use this file except in compliance with
* the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is by Greg Yardley
*
* The Initial Developer of the Original Code is
*   Greg Yardley
* Portions created by the Initial Developer are Copyright (C) 2007
* the Initial Developer. All Rights Reserved.
*
* Contributor(s):
*   Trevor Hobson
*
* Alternatively, the contents of this file may be used under the terms of
* either the GNU General Public License Version 2 or later (the "GPL"), or
* the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
* in which case the provisions of the GPL or the LGPL are applicable instead
* of those above. If you wish to allow use of your version of this file only
* under the terms of either the GPL or the LGPL, and not to allow others to
* use your version of this file under the terms of the MPL, indicate your
* decision by deleting the provisions above and replace them with the notice
* and other provisions required by the GPL or the LGPL. If you do not delete
* the provisions above, a recipient may use your version of this file under
* the terms of any one of the MPL, the GPL or the LGPL.
*
* ***** END LICENSE BLOCK ***** */

var objection = {
	nsIFilePicker: Components.interfaces.nsIFilePicker,
	nsILocalFile: new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile"),
	preferences: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection."),
	stringBundle: '',
	treeObject: null,
	treeObjectDetail: null,
	treeSettingThird: null,
	flashAppDir: null,
	flashObjectDir: null,
	flashSettingDir: null,
	flashSettingFile: null,
	arraySettingFile: [],
	arrayObject: [],
	arrayObjectDetail: [],
	arraySettingThird: [],
	countObject: 0,
	countSettingThird: 0,

	idGlobalCamera: 0,
	idGlobalSpace: 0,
	idGlobalThird: 0,
	idGlobalCache: 0,
	idGlobalSecurity: 0,
	idGlobalUpdateDisabled: 0,
	idGlobalUpdateInterval: 0,
	idGlobalVideoAcceleration: 0,
	idTrustedPaths: 0,
	idTrustedPathsEnd: 0,
	idDomains: 0,
	idDomainsEnd: 0,

	sortOrderObject: ['site', 'object'],
	sortOrderThird: ['name'],

	locGlobal: 'Global',
	locNever: 'Never',
	locNone: 'None',
	locUnlimited: 'Unlimited',
	locAlwaysAsk: 'Always Ask',
	locAlwaysAllow: 'Always Allow',
	locAlwaysDeny: 'Always Deny',

	platformFlashAppDir: '',

	viewObject:
	{
		rowCount: 0,
		setTree: function(treeBox) {this.treeBox = treeBox;},
		getImageSrc: function(row, column) {},
		getProgressMode: function(row, column) {},
		getCellValue: function(row, column) {},
		getCellText: function(row, column) {
			var rv="";
			//try
			//{
				if (objection.arrayObject[row].isSite)
				{
					if (!objection.arrayObject[row].isRead)
					{
						objection.getSiteSettingDetail(row);
					}
					if (column.id=="colName")
					{
						rv = objection.arrayObject[row].site;
					}
					else if (column.id=="colUsed")
					{
						var usedSiteB = objection.arrayObject[row].used;
						var usedSiteK = usedSiteB / 1024;
						var usedSiteM = usedSiteK / 1024;
						if (usedSiteB < 1024)
						{
							rv = usedSiteB + " bytes";
						}
						else if (usedSiteK < 1024)
						{
							rv = usedSiteK.toFixed(1) + " KB";
						}
						else
						{
							rv = usedSiteM.toFixed(1) + " MB";
						}
					}
					else if (column.id=="colLimit")
					{
						var limitSite = objection.arrayObject[row].limit;
						if (limitSite == -1)
						{
							rv = objection.locNever;
						}
						else if (limitSite == 0)
						{
							rv = objection.locNone;
						}
						else if (limitSite == 10)
						{
							rv = "10 KB";
						}
						else if (limitSite == 100)
						{
							rv = "100 KB";
						}
						else if (limitSite == 1024)
						{
							rv = "1 MB";
						}
						else if (limitSite == 10240)
						{
							rv = "10 MB";
						}
						else if (limitSite == -2)
						{
							rv = objection.locUnlimited;
						}
						else
						{
							rv = objection.locGlobal;
						}
					}
					else if (column.id=="colPrivacy")
					{
						var privacySite = objection.arrayObject[row].privacy;
						if (privacySite == 1)
						{
							rv = objection.locAlwaysAsk;
						}
						else if (privacySite == 2)
						{
							rv = objection.locAlwaysAllow;
						}
						else if (privacySite == 3)
						{
							rv = objection.locAlwaysDeny;
						}
						else
						{
							rv = objection.locGlobal;
						}
					}
				}
				else
				{
					if (column.id=="colName")
					{
						rv = objection.arrayObject[row].object;
					}
					else if (column.id=="colUsed")
					{
						rv = objection.arrayObject[row].size + " bytes";
						var sizeSiteB = objection.arrayObject[row].size;
						var sizeSiteK = sizeSiteB / 1024;
						var sizeSiteM = sizeSiteK / 1024;
						if (sizeSiteB < 1024)
						{
							rv = sizeSiteB + " bytes";
						}
						else if (sizeSiteK < 1024)
						{
							rv = sizeSiteK.toFixed(1) + " KB";
						}
						else
						{
							rv = sizeSiteM.toFixed(1) + " MB";
						}
					}
					else if (column.id=="colLimit")
					{
						rv = "";
					}
					else if (column.id=="colPrivacy")
					{
						rv = "";
					}
				}
			//} catch(er){}
			return rv;
		},
		getParentIndex: function(row) {
			var rv = -1;
			try
			{
				if (objection.arrayObject[row].level > 0)
				{
					for (var t=row-1; t>=0; t--)
					{
						if (objection.arrayObject[t].level < objection.arrayObject[row].level)
						{
							rv = t;
						}
					}
				}
			} catch(er){}
			return rv;
		},
		getLevel: function(row) {
			var rv = 0;
			try
			{
				rv = objection.arrayObject[row].level;
			} catch(er){}
			return rv;
		},
		isSeparator: function(index) {return false;},
		isSorted: function() {return false;},
		isContainer: function(row) {return false;}, // Say false because we don't want the twistie
		isContainerOpen: function(row) {return true;},
		isContainerEmpty: function(row) {return false;},
		isEditable: function(row, column) {return false;},
		hasNextSibling: function(row, after) {
			var rv = false;
			try
			{
				var thisLevel = objection.arrayObject[row].level;
				for (var t = row+1; t < objection.arrayObject.length; t++)
				{
					var nextLevel = objection.arrayObject[t].level;
					if (nextLevel == thisLevel)
					{
						rv = true;
						break;
					}
					else if (nextLevel < thisLevel)
					{
						rv = false;
						break;
					}
				}
			} catch(er){}
			return rv;
		},
		toggleOpenState: function(row) {},
		cycleHeader: function(aColId, aElt) {},
		selectionChanged: function() {},
		cycleCell: function(row, column) {},
		performAction: function(action) {},
		performActionOnCell: function(action, row, column) {},
		getRowProperties: function(row, props) {},
		getColumnProperties: function(column, props) {},
		getCellProperties: function(row, column, props) {},
	},

	viewObjectDetail:
	{
		rowCount: 0,
		setTree: function(treeBox) {this.treeBox = treeBox;},
		getImageSrc: function(row, column) {},
		getProgressMode: function(row, column) {},
		getCellValue: function(row, column) {},
		getCellText: function(row, column) {
			var rv="";
			try
			{
				if (column.id=="colName")
				{
					rv = objection.arrayObjectDetail[row].name;
				}
				else if (column.id=="colType")
				{
					rv = objection.arrayObjectDetail[row].type;
				}
				else if (column.id=="colValue")
				{
					if (objection.arrayObjectDetail[row].type == "pointer")
					{
						rv = '[' + objection.arrayObjectDetail[row].value + '] err';
						for (var i=0; i < objection.arrayObjectDetail.length; i++)
						{
							if (objection.arrayObjectDetail[row].value == objection.arrayObjectDetail[i].target)
							{
								rv = '[' + objection.arrayObjectDetail[row].value + '] ' + objection.arrayObjectDetail[i].name + ' (' + objection.arrayObjectDetail[i].type + ')';
								break;
							}
						}
					}
					else
					{
						rv = objection.arrayObjectDetail[row].value;
					}
				}
			} catch(er){}
			return rv;
		},
		getParentIndex: function(row) {
			var rv = -1;
			try
			{
				if (objection.arrayObjectDetail[row].level > 0)
				{
					for (var t=row-1; t>=0; t--)
					{
						if (objection.arrayObjectDetail[t].level < objection.arrayObjectDetail[row].level)
						{
							rv = t;
							break
						}
					}
				}
			} catch(er){}
			return rv;
		},
		getLevel: function(row) {
			var rv = 0;
			try
			{
				rv = objection.arrayObjectDetail[row].level;
			} catch(er){}
			return rv;
		},
		isSeparator: function(index) {return false;},
		isSorted: function() {return false;},
		isContainer: function(row) {return false;}, // Say false because we don't want the twistie
		isContainerOpen: function(row) {return true;},
		isContainerEmpty: function(row) {return false;},
		isEditable: function(row, column) {return false;},
		hasNextSibling: function(row, after) {
			var rv = false;
			try
			{
				var thisLevel = objection.arrayObjectDetail[row].level;
				for (var t = row+1; t < objection.arrayObjectDetail.length; t++)
				{
					var nextLevel = objection.arrayObjectDetail[t].level;
					if (nextLevel == thisLevel)
					{
						rv = true;
						break;
					}
					else if (nextLevel < thisLevel)
					{
						rv = false;
						break;
					}
				}
			} catch(er){}
			return rv;
		},
		toggleOpenState: function(row) {},
		cycleHeader: function(aColId, aElt) {},
		selectionChanged: function() {},
		cycleCell: function(row, column) {},
		performAction: function(action) {},
		performActionOnCell: function(action, row, column) {},
		getRowProperties: function(row, props) {},
		getColumnProperties: function(column, props) {},
		getCellProperties: function(row, column, props) {},
	},

	viewSettingThird:
	{
		rowCount: 0,
		setTree: function(treeBox) {this.treeBox = treeBox;},
		getImageSrc: function(row, column) {},
		getProgressMode: function(row, column) {},
		getCellValue: function(row, column) {},
		getCellText: function(row, column) {
			var rv="";
			if (column.id=="colSite")
			{
				rv = objection.arraySettingThird[row];
			}
			return rv;
		},
		isSeparator: function(index) {return false;},
		isSorted: function() {return false;},
		isContainer: function(index) {return false;},
		cycleHeader: function(aColId, aElt) {},
		getRowProperties: function(row, props) {},
		getColumnProperties: function(column, props) {},
		getCellProperties: function(row, column, props) {},
	},

	frameObject: function(number, site, object, used, size, limit, privacy, level, file, isSite, isRead)
	{
		this.number = number;
		this.site = site;
		this.object = object;
		this.used = used;
		this.size = size;
		this.limit = limit;
		this.privacy = privacy;
		this.level = level;
		this.file = file;
		this.isSite = isSite;
		this.isRead = isRead;
		return this;
	},

	init: function()
	{
		// Reference string bundle set
		objection.stringBundle = document.getElementById('objectionStrings');

		// Read string bundle to variables (not all)
		objection.locGlobal = objection.stringBundle.getString("global");
		objection.locNever = objection.stringBundle.getString("never");
		objection.locNone = objection.stringBundle.getString("none");
		objection.locUnlimited = objection.stringBundle.getString("unlimited");
		objection.locAlwaysAsk = objection.stringBundle.getString("alwaysAsk");
		objection.locAlwaysAllow = objection.stringBundle.getString("alwaysAllow");
		objection.locAlwaysDeny = objection.stringBundle.getString("alwaysDeny");

		// Reference the trees
		objection.treeObject = document.getElementById('treeObject');
		objection.treeObjectDetail = document.getElementById('treeObjectDetail');
		objection.treeSettingThird = document.getElementById('treeSettingThird');

		// Init the File/Directory objects
		objection.flashAppDir = new objection.nsILocalFile();
		objection.flashSettingDir = new objection.nsILocalFile();
		objection.flashSettingFile = new objection.nsILocalFile();
		objection.flashObjectDir = new objection.nsILocalFile();

		// Set the platform specific flashAppDir preference name
		objection.platformFlashAppDir = 'flashAppDir';
		var thisPlatform = window.navigator.platform;
		if (thisPlatform == "Win32" || thisPlatform == "MacPPC")
		{
			objection.platformFlashAppDir += thisPlatform;
		}
		else
		{
			objection.platformFlashAppDir += 'Other';
		}
		
		// Get the Flash data directory
		if (objection.preferences.prefHasUserValue(objection.platformFlashAppDir) && typeof(objection.preferences.getCharPref(objection.platformFlashAppDir)) != 'undefined')
		{
			var flashAppDirPref = objection.preferences.getCharPref(objection.platformFlashAppDir);
			objection.flashAppDir.initWithPath(flashAppDirPref);
			if (!(objection.flashAppDir.exists() && objection.flashAppDir.isDirectory()))
			{
				objection.flashAppDir = null;
			}
		}
		else
		{
			// Check the non platfrom specific preference (The old one)
			if (objection.preferences.prefHasUserValue("flashAppDir") && typeof(objection.preferences.getCharPref("flashAppDir")) != 'undefined')
			{
				var flashAppDirPref = objection.preferences.getCharPref("flashAppDir");
				objection.flashAppDir.initWithPath(flashAppDirPref);
				if (objection.flashAppDir.exists() && objection.flashAppDir.isDirectory())
				{
					objection.preferences.setCharPref(objection.platformFlashAppDir, flashAppDirPref);
				}
				else
				{
					objection.flashAppDir = objection.getFlashAppDir();  // Preference may have been from a different platform, so try and find the one for this
				}
			}
			else
			{
				objection.flashAppDir = objection.getFlashAppDir();
			}
		}
		// If there is not a valid Flash data directory then send the user to the Folder pane
		if (objection.flashAppDir == null)
		{
			document.getElementById("flashAppDir").value = objection.stringBundle.getString("dirNotFound");
			document.getElementById("objectionPreferences").showPane(document.getElementById("paneFolder"));
			return;
		}
		document.getElementById("flashAppDir").value = objection.flashAppDir.path;

		// Set the options (Folder) pane
		objection.onAutomaticRemoveChange();

		// Reset arrays
		objection.arraySettingFile = new Array();
		objection.arrayObject = new Array();
		objection.arrayObjectDetail = new Array();
		objection.arraySettingThird = new Array();

		// Reset counters
		objection.countObject = 0;
		objection.countObjectDetail = 0;
		objection.countSettingThird = 0;

		// Rest setting file pointers
		objection.idGlobalCamera = 0;
		objection.idGlobalSpace = 0;
		objection.idGlobalThird = 0;
		objection.idGlobalCache = 0;
		objection.idGlobalSecurity = 0;
		objection.idGlobalUpdateDisabled = 0;
		objection.idGlobalUpdateInterval = 0;
		objection.idGlobalVideoAcceleration = 0;
		objection.idTrustedPaths = 0;
		objection.idTrustedPathsEnd = 0;
		objection.idDomains = 0;
		objection.idDomainsEnd = 0;

		// Init the Object Detail Tree
		objection.viewObjectDetail.rowCount = 0;
		objection.treeObjectDetail.view = objection.viewObjectDetail;

		// Run the main function
		objection.main();
	},

	main: function()
	{
		var hasFlashSetting = objection.getFlashSetting();
		if (objection.flashSettingDir != null)
		{
			objection.getSiteSetting();
		}
		var hasObjectDir = objection.getObjectDir();
		if (hasFlashSetting)
		{
			// Show flash settings
			objection.showSettingFlash();

			// Sort third (party) array
			objection.sortArrayAscending(objection.arraySettingThird, objection.sortOrderThird);

			// Set third (party) tree
			objection.viewSettingThird.rowCount = objection.arraySettingThird.length;
			objection.treeSettingThird.view = objection.viewSettingThird;
			objection.treeSettingThird.treeBoxObject.invalidate();
		}
		if (hasObjectDir)
		{
			objection.getObject()

			// Sort object array
			objection.sortArrayAscending(objection.arrayObject, objection.sortOrderObject);

			// Set object tree
			objection.viewObject.rowCount = objection.arrayObject.length;
			objection.treeObject.view = objection.viewObject;
			objection.treeObject.treeBoxObject.invalidate();
		}
	},

	// Get Flash player settings
	getFlashSetting: function()
	{
		var returnSet = false;
		objection.flashSettingDir.initWithFile(objection.flashAppDir);
		objection.flashSettingDir.appendRelativePath('macromedia.com');
		objection.flashSettingDir.appendRelativePath('support');
		objection.flashSettingDir.appendRelativePath('flashplayer');
		objection.flashSettingDir.appendRelativePath('sys');
		if (objection.flashSettingDir.exists() && objection.flashSettingDir.isDirectory())
		{
			objection.flashSettingFile.initWithFile(objection.flashSettingDir);
			objection.flashSettingFile.append('settings.sol');
			if (objection.flashSettingFile.exists() && objection.flashSettingFile.isFile())
			{
				objection.arraySettingFile = objectionSolRead.read(objection.flashSettingFile);
				if (objection.arraySettingFile != null)
				{
					returnSet = true;
					objection.idGlobalCamera = objection.setId(objection.arraySettingFile, 'defaultalways');
					objection.idGlobalSpace = objection.setId(objection.arraySettingFile, 'defaultklimit');
					objection.idGlobalThird = objection.setId(objection.arraySettingFile, 'allowThirdPartyLSOAccess');
					objection.idGlobalCache = objection.setId(objection.arraySettingFile, 'secureCrossDomainCacheSize');
					objection.idGlobalSecurityAllow = objection.setId(objection.arraySettingFile, 'crossdomainAllow');
					objection.idGlobalSecurityAlways = objection.setId(objection.arraySettingFile, 'crossdomainAlways');
					objection.idGlobalUpdateDisabled = objection.setId(objection.arraySettingFile, 'autoUpdateDisabled');
					objection.idGlobalUpdateInterval = objection.setId(objection.arraySettingFile, 'autoUpdateInterval');
					objection.idGlobalVideoAcceleration = objection.setId(objection.arraySettingFile, 'safefullscreen');
					objection.idTrustedPaths = objection.setId(objection.arraySettingFile, 'trustedPaths');
					objection.idDomains = objection.setId(objection.arraySettingFile, 'domains');
					if (objection.idDomains > 0)
					{
						var i = objection.idDomains + 1;
						var settingLevel = (i < objection.arraySettingFile.length) ? objection.arraySettingFile[i].level : 0;
						while (settingLevel == 1)
						{
							var flashSettingSite = (objection.arraySettingFile[i].name != 'local') ? objection.arraySettingFile[i].name : 'localhost';
							objection.arrayObject[objection.countObject] = new objection.frameObject(objection.countObject++, flashSettingSite, '', 0, -10, -10, -10, 0, null, true, false);
							i++;
							settingLevel = (i < objection.arraySettingFile.length) ? objection.arraySettingFile[i].level : 0;
						}
						objection.idDomainsEnd = i - 1;
						if (objection.idDomainsEnd > objection.idDomains + 2)
						{
							objection.sortSettingSite(objection.idDomains + 1, objection.idDomainsEnd);
						}
					}
					if (objection.idTrustedPaths > 0)
					{
						var i = objection.idTrustedPaths + 1;
						var settingLevel = (i < objection.arraySettingFile.length) ? objection.arraySettingFile[i].level : 0;
						while (settingLevel == 1)
						{
							objection.arraySettingThird[objection.countSettingThird] = objection.arraySettingFile[i].name;
							objection.countSettingThird++;
							i++;
							settingLevel = (i < objection.arraySettingFile.length) ? objection.arraySettingFile[i].level : 0;
						}
						objection.idTrustedPathsEnd = i - 1;
						if (objection.idTrustedPathsEnd > objection.idTrustedPaths + 2)
						{
							objection.sortSettingSite(objection.idTrustedPaths + 1, objection.idTrustedPathsEnd);
						}
					}
				}
			}
			else
			{
				objection.flashSettingFile = null;
			}
		}
		else
		{
			objection.flashSettingDir = null;
			objection.flashSettingFile = null;
		}
		return returnSet;
	},

	getSiteSetting: function()
	{
		try
		{
			var entries = objection.flashSettingDir.directoryEntries;
		} catch(er)
		{
			return;
		}
		while(entries.hasMoreElements())
		{
			var entry = entries.getNext();
			entry.QueryInterface(Components.interfaces.nsIFile);
			if (entry.isDirectory())
			{
				var settingSite = entry.leafName;
				settingSite = settingSite.replace('#','');
				settingSite = (settingSite != 'local') ? settingSite : 'localhost';
				var isSet = false;
				entry.append('settings.sol');
				var settingFile = null;
				if ((entry.exists()) && (entry.isFile()))
				{
					settingFile = entry;
				}
				for (var j=0; j < objection.arrayObject.length; j++)
				{
					if (objection.arrayObject[j].site == settingSite)
					{

						objection.arrayObject[j].file = settingFile;
						isSet = true;
						break;
					}
				}
				if (!isSet)
				{
					objection.arrayObject[objection.countObject] = new objection.frameObject(objection.countObject++, settingSite, '', 0, -1, -10, -10, 0, settingFile, true, false);
				}
			}
		}
	},

	getSiteSettingDetail: function(indexObject)
	{
		if (objection.arrayObject[indexObject].isSite && !objection.arrayObject[indexObject].isRead)
		{
			var settingFile = objection.arrayObject[indexObject].file;
			if (settingFile != null)
			{
				if ((settingFile.exists()) && (settingFile.isFile()))
				{
					var arraySiteSettingDetail = objectionSolRead.read(settingFile);
					var idSiteSpace = objection.setId(arraySiteSettingDetail, 'klimit');
					var idSiteSecurityAllow = objection.setId(arraySiteSettingDetail, 'allow');
					var idSiteSecurityAlways = objection.setId(arraySiteSettingDetail, 'always');
					var siteSettingSpace = (idSiteSpace !=0) ? arraySiteSettingDetail[idSiteSpace].value : -10;
					var siteSettingSecurity = -10;
					if (idSiteSecurityAllow != 0 && idSiteSecurityAlways !=0)
					{
						siteSettingSecurity = (arraySiteSettingDetail[idSiteSecurityAllow].value == 'true' && arraySiteSettingDetail[idSiteSecurityAlways].value == 'true') ? '2' : (arraySiteSettingDetail[idSiteSecurityAlways].value == 'true') ? '3' : (arraySiteSettingDetail[idSiteSecurityAlways].value == 'false') ? '1' : '-';
					}
					objection.arrayObject[indexObject].limit = siteSettingSpace;
					objection.arrayObject[indexObject].privacy = siteSettingSecurity;
				}
			}
			objection.arrayObject[indexObject].isRead = true;
		}
	},

	getObjectDir: function()
	{
		var returnSet = false;
		objection.flashObjectDir.initWithFile(objection.flashAppDir);
		objection.flashObjectDir.appendRelativePath('#SharedObjects');
		if (objection.flashObjectDir.exists() && objection.flashObjectDir.isDirectory())
		{
			try
			{
				var entries = objection.flashObjectDir.directoryEntries;
				while(entries.hasMoreElements())
				{
					var entry = entries.getNext();
					entry.QueryInterface(Components.interfaces.nsIFile);
					if (entry.isDirectory())
					{
						objection.flashObjectDir.initWithFile(entry);
						returnSet = true;
						break;
					}
				}
			} catch(er) {}
		}
		return returnSet;
	},

	getObject: function()
	{
		try
		{
			var entries = objection.flashObjectDir.directoryEntries;
		} catch(er)
		{
			return;
		}
		while(entries.hasMoreElements())
		{
			var entry = entries.getNext();
			entry.QueryInterface(Components.interfaces.nsIFile);
			if (entry.isDirectory())
			{
				var settingSite = entry.leafName;
				var settingSiteId = -1;
				for (var j=0; j < objection.arrayObject.length; j++)
				{
					if (objection.arrayObject[j].site == settingSite && objection.arrayObject[j].isSite)
					{
						settingSiteId = j;
						break;
					}
				}
				if (settingSiteId < 0)
				{
					settingSiteId = objection.countObject;
					objection.arrayObject[objection.countObject] = new objection.frameObject(objection.countObject++, settingSite, '', 0, -1, -10, -10, 0, null, true, false);
				}
				objection.getObjectSite(settingSite, settingSiteId, entry);
			}
		}
	},

	getObjectSite: function(settingSite, settingSiteId, searchDir)
	{
		try
		{
			var entries = searchDir.directoryEntries;
		} catch(er)
		{
			return;
		}
		while(entries.hasMoreElements())
		{
			var entry = entries.getNext();
			entry.QueryInterface(Components.interfaces.nsIFile);
			if (entry.isFile())
			{
				var leaf = entry.leafName;
				var dotIndex  = leaf.lastIndexOf('.');
				var extension = (dotIndex >= 0) ? leaf.substring(dotIndex+1) : "";
				if ((extension == "sol")||(extension == "fso"))
				{
					objection.arrayObject[objection.countObject] = new objection.frameObject(objection.countObject++, settingSite, entry.leafName, -1, entry.fileSize, -10, -10, 1, entry, false, false);
					objection.arrayObject[settingSiteId].used = objection.arrayObject[settingSiteId].used + entry.fileSize;
				}
			}
			else if (entry.isDirectory())
			{
				objection.getObjectSite(settingSite, settingSiteId, entry);
			}
		}
	},

	setId: function(checkArray, itemName)
	{
		if (checkArray != null)
		{
			for (var i=0; i < checkArray.length; i++)
			{
				if (checkArray[i].name == itemName)
				{
					return i;
				}
			}
		}
		return 0;
	},

	treeObjectSelected: function()
	{
		var indexObject = objection.treeObject.currentIndex;
		if (indexObject > -1)
		{
			if (objection.arrayObject[indexObject].isSite)
			{
				document.getElementById("groupObjectDetail").setAttribute("collapsed", "true");
				document.getElementById("buttonObjectDeleteSelected").setAttribute("collapsed", "true");
				document.getElementById("groupSiteDetail").removeAttribute("collapsed");
				document.getElementById("buttonSiteDeleteSelected").removeAttribute("collapsed");
			}
			else
			{
				document.getElementById("groupSiteDetail").setAttribute("collapsed", "true");
				document.getElementById("buttonSiteDeleteSelected").setAttribute("collapsed", "true");
				document.getElementById("groupObjectDetail").removeAttribute("collapsed");
				document.getElementById("buttonObjectDeleteSelected").removeAttribute("collapsed");
			}
			objection.showObjectDetail(indexObject);
		}
		else
		{
			document.getElementById("groupObjectDetail").setAttribute("collapsed", "true");
			document.getElementById("groupSiteDetail").setAttribute("collapsed", "true");
			document.getElementById("buttonObjectDeleteSelected").setAttribute("collapsed", "true");
			document.getElementById("buttonSiteDeleteSelected").setAttribute("collapsed", "true");
			objection.hideObjectDetail();
		}
	},

	treeObjectKeyPress: function(e)
	{
		if (e.keyCode == 46)
		{
			objection.deleteObjectSelected();
		}
	},

	treeSettingThirdSelected: function()
	{
		var indexObject = objection.treeSettingThird.currentIndex;
		if (indexObject > -1)
		{
			document.getElementById("buttonDeleteThirdSelected").removeAttribute("disabled");
		}
		else
		{
			document.getElementById("buttonDeleteThirdSelected").setAttribute("disabled", "true");
		}
	},

	showObjectDetail: function(indexObject)
	{
		// Reset the tree
		objection.treeObjectDetail.treeBoxObject.beginUpdateBatch();
		objection.viewObjectDetail.rowCount = 0;
		objection.treeObjectDetail.treeBoxObject.rowCountChanged(0, -objection.arrayObjectDetail.length);
		objection.arrayObjectDetail = new Array();
		if (!objection.arrayObject[indexObject].isSite)
		{
			// Show sol file path
			var pathSolFull = objection.arrayObject[indexObject].file.path;
			var pathSolShort = '...' + pathSolFull.substring(objection.flashObjectDir.path.length)
			document.getElementById("textObjectDetailPath").value = pathSolShort;

			// If sol file still exists (may have been moved or deleted)
			if ((objection.arrayObject[indexObject].file.exists()) && (objection.arrayObject[indexObject].file.isFile()))
			{
				// Get sol file content
				objection.arrayObjectDetail = objectionSolRead.read(objection.arrayObject[indexObject].file);

				// Show sol content in tree
				objection.viewObjectDetail.rowCount = objection.arrayObjectDetail.length;
				objection.treeObjectDetail.treeBoxObject.rowCountChanged(0, objection.arrayObjectDetail.length);
			}
		}
		else
		{
			// Show site Used space
			var siteUsed = 0;
			var siteUsedB = objection.arrayObject[indexObject].used;
			var siteUsedK = siteUsedB / 1024;
			var siteUsedM = siteUsedK / 1024;
			if (siteUsedB < 1024)
			{
				siteUsed = siteUsedB + " bytes";
			}
			else if (siteUsedK < 1024)
			{
				siteUsed = siteUsedK.toFixed(1) + " KB";
			}
			else
			{
				siteUsed = siteUsedM.toFixed(1) + " MB";
			}
			document.getElementById("textSiteUsed").value = siteUsed;

			// Set delete site LSOs button state
			if (siteUsedB > 0)
			{
				document.getElementById("buttonSiteDeleteSelected").removeAttribute("disabled");
			}
			else
			{
				document.getElementById("buttonSiteDeleteSelected").setAttribute("disabled", "true");
			}

			// Show site Limit and Privacy
			var siteLimit = objection.arrayObject[indexObject].limit;
			var sitePrivacy = objection.arrayObject[indexObject].privacy;
			document.getElementById("settingSiteSpace").value = siteLimit;
			document.getElementById("settingSiteCamera").value = sitePrivacy;

			// Set delete settings button state
			if (objection.arrayObject[indexObject].file != null)
			{
				document.getElementById("buttonSiteDeleteSetting").removeAttribute("disabled");
			}
			else
			{
				document.getElementById("buttonSiteDeleteSetting").setAttribute("disabled", "true");
			}
		}
		// Show sol content in tree
		objection.treeObjectDetail.treeBoxObject.endUpdateBatch();
	},

	hideObjectDetail: function()
	{
		// Rest detail array and tree
		objection.arrayObjectDetail = new Array();
		objection.viewObjectDetail.rowCount = objection.arrayObjectDetail.length;
		objection.treeObjectDetail.view = objection.viewObjectDetail;
		objection.treeObjectDetail.treeBoxObject.invalidate();

		// Remove the path
		document.getElementById("textObjectDetailPath").value = '';
	},

	deleteSiteSelected: function()
	{
		var indexObject = objection.treeObject.currentIndex;
		if (indexObject > -1)
		{
			if (objection.arrayObject[indexObject].isSite)
			{
				if (confirm(objection.stringBundle.getString("confirmSiteLsoRemove")))
				{
					var objectSite = objection.arrayObject[indexObject].site;
					objection.arrayObject[indexObject].used = 0;
					var deleteCount = 0;
					var treeBox = objection.treeObject.treeBoxObject;
					treeBox.beginUpdateBatch();
					for (var j=objection.arrayObject.length-1; j>-1; j--)
					{
						if (objection.arrayObject[j].site == objectSite && !objection.arrayObject[j].isSite)
						{
							// Delete the file
							objection.deleteFile(objection.arrayObject[j].file, false);
							deleteCount++;
							objection.arrayObject.splice(j, 1);
						}
					}
					objection.viewObject.rowCount -= deleteCount;
					treeBox.rowCountChanged(indexObject, -deleteCount);
					treeBox.view.selection.select(indexObject < objection.arrayObject.length ? indexObject : objection.arrayObject.length - 1)
					treeBox.endUpdateBatch();
					treeBox.ensureRowIsVisible(objection.treeObject.currentIndex);

					// Delete the whole site directory
					objection.deleteObjectSiteDir(objectSite);
				}
			}
		}
	},

	deleteObjectSelected: function()
	{
		var indexObject = objection.treeObject.currentIndex;
		if (indexObject > -1)
		{
			if (!objection.arrayObject[indexObject].isSite)
			{
				if (confirm(objection.stringBundle.getString("confirmLsoRemove")))
				{
					// Delete the file
					objection.deleteFile(objection.arrayObject[indexObject].file, false);

					// Remove the file size from the site listing
					var objectSize = objection.arrayObject[indexObject].size;
					var objectSite = objection.arrayObject[indexObject].site;
					for (var j=0; j < objection.arrayObject.length; j++)
					{
						if (objection.arrayObject[j].site == objectSite && objection.arrayObject[j].isSite)
						{
							objection.arrayObject[j].used -= objectSize;
							if (objection.arrayObject[j].used == 0)
							{
								// Delete the whole site directory
								objection.deleteObjectSiteDir(objection.arrayObject[j].site);
							}
							break;
						}
					}

					// Delete from tree and update
					objection.deleteTreeSelectionSingle(objection.treeObject, objection.viewObject, objection.arrayObject);
					objection.treeObjectSelected();
				}
			}
		}
	},

	deleteObjectAll: function()
	{
		if (confirm(objection.stringBundle.getString("confirmLsoRemoveAll")))
		{
			var treeBox = objection.treeObject.treeBoxObject;
			treeBox.beginUpdateBatch();
			for (var j=objection.arrayObject.length-1; j>-1; j--)
			{
				if (objection.arrayObject[j].isSite)
				{
					objection.arrayObject[j].used = 0;
				}
				else
				{
					// Delete the file
					objection.deleteFile(objection.arrayObject[j].file, false);
					objection.arrayObject.splice(j, 1);
					objection.viewObject.rowCount--;
					treeBox.rowCountChanged(j, -1);
				}
			}
			treeBox.view.selection.select(-1)
			treeBox.endUpdateBatch();
			treeBox.ensureRowIsVisible(objection.treeObject.currentIndex);

			// Delete all site directories
			try
			{
				var entries = objection.flashObjectDir.directoryEntries;
			} catch(er)
			{
				return;
			}
			while(entries.hasMoreElements())
			{
				var entry = entries.getNext();
				entry.QueryInterface(Components.interfaces.nsIFile);
				if (entry.isDirectory())
				{
					objection.deleteFile(entry, true);
				}
			}
		}
	},

	deleteSiteSetting: function()
	{
		var indexObject = objection.treeObject.currentIndex;
		if (indexObject > -1)
		{
			if (objection.arrayObject[indexObject].isSite)
			{
				if (confirm(objection.stringBundle.getString("confirmSiteSettingRemove")))
				{
					// Delete the site setting directory
					var siteSettingDir = new objection.nsILocalFile();
					siteSettingDir.initWithFile(objection.flashSettingDir);
					siteSettingDir.appendRelativePath('#' + objection.arrayObject[indexObject].site);
					objection.deleteFile(siteSettingDir, true);

					// Update array and user interface
					if (objection.arrayObject[indexObject].used == 0)
					{
						objection.deleteTreeSelectionSingle(objection.treeObject, objection.viewObject, objection.arrayObject);
					}
					else
					{
						objection.arrayObject[indexObject].limit = -10;
						objection.arrayObject[indexObject].privacy = -10;
						objection.treeObject.treeBoxObject.invalidateRow(indexObject);
						document.getElementById("settingSiteSpace").value = -10;
						document.getElementById("settingSiteCamera").value = -10;
					}
					objection.arrayObject[indexObject].file = null;
				}
			}
		}
	},

	saveSiteSetting: function()
	{
		var indexObject = objection.treeObject.currentIndex;
		if (indexObject > -1)
		{
			// Get user values
			var siteLimit = document.getElementById("settingSiteSpace").value;
			var sitePrivacy = document.getElementById("settingSiteCamera").value;

			// Update array and user interface
			objection.arrayObject[indexObject].limit = siteLimit;
			objection.arrayObject[indexObject].privacy = sitePrivacy;
			objection.treeObject.treeBoxObject.invalidateRow(indexObject);

			// Create site setting file object
			var siteSettingDir = new objection.nsILocalFile();
			siteSettingDir.initWithFile(objection.flashSettingDir);
			siteSettingDir.appendRelativePath('#' + objection.arrayObject[indexObject].site);
			var siteSettingFile = new objection.nsILocalFile();
			siteSettingFile.initWithFile(siteSettingDir);
			siteSettingFile.append('settings.sol');

			// If settings are set to global then we delete the site setting directory
			if (siteLimit == -10 && sitePrivacy == -10)
			{
				objection.deleteFile(siteSettingDir, true);
			}
			else
			{
				if (!siteSettingDir.exists())
				{
					siteSettingDir.create(1,0777);
				}
				var countSiteSetting = 0;
				var arraySiteSetting = new Array();
				arraySiteSetting[countSiteSetting] = new objectionSolRead.contentFrame(countSiteSetting++, 'name', objection.arrayObject[indexObject].site + '/settings', '', 0, false, 0);
				if (siteLimit != -10)
				{
					arraySiteSetting[countSiteSetting] = new objectionSolRead.contentFrame(countSiteSetting++, 'number', 'klimit', siteLimit, 0, false, 0);
				}
				if (sitePrivacy != -10)
				{
					var siteSecurityAllow = (sitePrivacy == 2) ? 'true' : 'false';
					var siteSecurityAlways = (sitePrivacy == 2 || sitePrivacy == 3) ? 'true' : 'false';
					arraySiteSetting[countSiteSetting] = new objectionSolRead.contentFrame(countSiteSetting++, 'boolean', 'allow', siteSecurityAllow, 0, false, 0);
					arraySiteSetting[countSiteSetting] = new objectionSolRead.contentFrame(countSiteSetting++, 'boolean', 'always', siteSecurityAlways, 0, false, 0);
				}
				var writeSuccess = objectionSolWrite.writer(siteSettingFile, arraySiteSetting);
				if (writeSuccess)
				{
					objection.arrayObject[indexObject].file = siteSettingFile;
				}
			}
		}
	},

	saveGlobalSetting: function()
	{
		if (objection.flashAppDir != null)
		{
			if (objection.flashSettingDir == null)
			{
				objection.flashSettingDir.initWithFile(objection.flashAppDir);
				objection.flashSettingDir.appendRelativePath('macromedia.com');
				objection.flashSettingDir.appendRelativePath('support');
				objection.flashSettingDir.appendRelativePath('flashplayer');
				objection.flashSettingDir.appendRelativePath('sys');
				if (!siteSettingDir.exists())
				{
					siteSettingDir.create(1,0777);
				}
			}
			if (objection.flashSettingFile == null)
			{
				objection.flashSettingFile = new objection.nsILocalFile();
				objection.flashSettingFile.initWithFile(objection.flashSettingDir);
				objection.flashSettingFile.append('settings.sol');
			}
			var settingGlobalCamera = document.getElementById("settingGlobalCamera").value;
			var settingGlobalSpace = document.getElementById("settingGlobalSpace").value;
			var settingGlobalThird = (document.getElementById("settingGlobalThird").checked == true) ? 'true' : 'false';
			var settingGlobalCache = (document.getElementById("settingGlobalCache").checked == true) ? '-1' : '0';
			var settingGlobalSecurity = document.getElementById("settingGlobalSecurity").value;
			var settingGlobalSecurityAllow = (settingGlobalSecurity == 2) ? 'true' : 'false';
			var settingGlobalSecurityAlways = (settingGlobalSecurity == 2 || settingGlobalSecurity == 3) ? 'true' : 'false';
			var settingGlobalUpdate = document.getElementById("settingGlobalUpdate").value;
			var settingGlobalUpdateDisabled = (settingGlobalUpdate == '-1') ? 'true' : 'false';
			var settingGlobalUpdateInterval = (settingGlobalUpdate != '-1') ? settingGlobalUpdate : '30';
			var settingVideoAcceleration = (document.getElementById("settingVideoAcceleration").checked == 'true') ? 'true' : 'false';
			if (objection.arraySettingFile == null || objection.arraySettingFile.length == 0)
			{
				objection.arraySettingFile = new Array();
				objection.arraySettingFile[0] = new objectionSolRead.contentFrame(0, 'name', 'settings', '', 0, false, 0);
			}
			objection.idGlobalCamera = objection.updateGlobalSetting(objection.idGlobalCamera, 'boolean', 'defaultalways', settingGlobalCamera);
			objection.idGlobalSpace = objection.updateGlobalSetting(objection.idGlobalSpace, 'number', 'defaultklimit', settingGlobalSpace);
			objection.idGlobalThird = objection.updateGlobalSetting(objection.idGlobalThird, 'boolean', 'allowThirdPartyLSOAccess', settingGlobalThird);
			objection.idGlobalCache = objection.updateGlobalSetting(objection.idGlobalCache, 'number', 'secureCrossDomainCacheSize', settingGlobalCache);
			objection.idGlobalSecurityAllow = objection.updateGlobalSetting(objection.idGlobalSecurityAllow, 'boolean', 'crossdomainAllow', settingGlobalSecurityAllow);
			objection.idGlobalSecurityAlways = objection.updateGlobalSetting(objection.idGlobalSecurityAlways, 'boolean', 'crossdomainAlways', settingGlobalSecurityAlways);
			objection.idGlobalUpdateDisabled = objection.updateGlobalSetting(objection.idGlobalUpdateDisabled, 'boolean', 'autoUpdateDisabled', settingGlobalUpdateDisabled);
			objection.idGlobalUpdateInterval = objection.updateGlobalSetting(objection.idGlobalUpdateInterval, 'number', 'autoUpdateInterval', settingGlobalUpdateInterval);
			objection.idGlobalVideoAcceleration = objection.updateGlobalSetting(objection.idGlobalVideoAcceleration, 'boolean', 'safefullscreen', settingVideoAcceleration);
			objection.idTrustedPaths = objection.updateGlobalSetting(objection.idTrustedPaths, 'object', 'trustedPaths', '');
			objection.idDomains = objection.updateGlobalSetting(objection.idDomains, 'object', 'domains', '');
			var writeSuccess = objectionSolWrite.writer(objection.flashSettingFile, objection.arraySettingFile);
			if (writeSuccess)
			{
				alert(objection.stringBundle.getString("messageSettingSaveGlobalSuccess"));
			}
			else
			{
				alert(objection.stringBundle.getString("messageSettingSaveGlobalFailure"));
				objection.flashSettingFile = null;
			}
		}
	},

	updateGlobalSetting: function(idSetting, typeSetting, nameSetting, valueSetting)
	{
		if (idSetting > 0)
		{
			objection.arraySettingFile[idSetting].value = valueSetting;
		}
		else
		{
			idSetting = objection.arraySettingFile.length;
			objection.arraySettingFile[idSetting] = new objectionSolRead.contentFrame(idSetting, typeSetting, nameSetting, valueSetting, 0, false, 0);
		}
		return idSetting;
	},

	deleteThirdSelected: function()
	{
		var indexObject = objection.treeSettingThird.currentIndex;
		if (indexObject > -1)
		{
			if (confirm(objection.stringBundle.getString("confirmThirdRemove")))
			{
				// Delete from tree and update (Changes will be saved on close)
				objection.deleteTreeSelectionSingle(objection.treeSettingThird, objection.viewSettingThird, objection.arraySettingThird);
				objection.treeSettingThirdSelected();
			}
		}
	},

	deleteThirdAll: function()
	{
		if (confirm(objection.stringBundle.getString("confirmThirdRemoveAll")))
		{
			// Delete from tree and update (Changes will be saved on close)
			var treeBox = objection.treeSettingThird.treeBoxObject;
			treeBox.beginUpdateBatch();
			objection.viewSettingThird.rowCount = 0;
			treeBox.rowCountChanged(0, -objection.arraySettingThird.length);
			treeBox.view.selection.select(-1);
			objection.arraySettingThird = new Array();
			treeBox.endUpdateBatch();
			objection.deleteTreeSelectionSingle(objection.treeSettingThird, objection.viewSettingThird, objection.arraySettingThird);
			objection.treeSettingThirdSelected();
		}
	},

	closeSave: function()
	{
		try
		{
			objection.deleteUnusedDir();
			objection.updateSettingFileSite();
			objection.updateSettingFileThird();
			objectionSolWrite.writer(objection.flashSettingFile, objection.arraySettingFile);
		} catch (er) {}
	},

	closeCancel: function()
	{
		try
		{
			objection.deleteUnusedDir();
			objection.updateSettingFileSite();
			objection.updateSettingFileThird();
			objectionSolWrite.writer(objection.flashSettingFile, objection.arraySettingFile);
		} catch (er) {}
	},

	showSettingFlash: function()
	{
		document.getElementById("settingGlobalCamera").value = (objection.idGlobalCamera != 0) ? objection.arraySettingFile[objection.idGlobalCamera].value : false;
		document.getElementById("settingGlobalSpace").value = (objection.idGlobalSpace !=0) ? objection.arraySettingFile[objection.idGlobalSpace].value : '100';
		document.getElementById("settingGlobalThird").checked = (objection.arraySettingFile[objection.idGlobalThird].value == 'false') ? false : true;
		document.getElementById("settingGlobalCache").checked = (objection.arraySettingFile[objection.idGlobalCache].value == '0') ? false : true;
		document.getElementById("settingGlobalSecurity").value = (objection.arraySettingFile[objection.idGlobalSecurityAllow].value == 'true' && objection.arraySettingFile[objection.idGlobalSecurityAlways].value == 'true') ? '2' : (objection.arraySettingFile[objection.idGlobalSecurityAlways].value == 'true') ? '3' : '1';
		document.getElementById("settingGlobalUpdate").value = (objection.arraySettingFile[objection.idGlobalUpdateDisabled].value == 'true') ? '-1' : (objection.idGlobalUpdateInterval != 0) ? objection.arraySettingFile[objection.idGlobalUpdateInterval].value : '30';
		document.getElementById("settingVideoAcceleration").checked = (objection.arraySettingFile[objection.idGlobalVideoAcceleration].value == 'false') ? true : false;
	},

	updateSettingFileSite: function()
	{
		if (objection.flashSettingDir != null && objection.flashSettingFile != null && objection.arraySettingFile != null)
		{
			// Create a new setting array
			var arraySettingFileNew = new Array();
			var pointerTarget = 0;
			var idDomainsNew = (objection.idDomains == 0) ? objection.arraySettingFile.length : objection.idDomains;
			var idDomainsEndNew = idDomainsNew;
			for (var i=0; i < idDomainsNew; i++)
			{
				arraySettingFileNew[i] = objection.arraySettingFile[i];
				pointerTarget = (objection.arraySettingFile[i].target != 0) ? objection.arraySettingFile[i].target : pointerTarget;
			}
			pointerTarget++;
			arraySettingFileNew[idDomainsNew] = new objectionSolRead.contentFrame(idDomainsNew, 'object', 'domains', '', 0, true, pointerTarget);
			for (var i=0; i < objection.arrayObject.length; i++)
			{
				var fileExists = (objection.arrayObject[i].file == null) ? false : objection.arrayObject[i].file.exists();
				if (objection.arrayObject[i].isSite && (objection.arrayObject[i].used > 0 || fileExists))
				{
					idDomainsEndNew++;
					var siteNew = (objection.arrayObject[i].site == 'localhost') ? 'local' : objection.arrayObject[i].site;
					arraySettingFileNew[idDomainsEndNew] = new objectionSolRead.contentFrame(idDomainsEndNew, 'boolean', siteNew, 'true', 1, true, 0);
				}
			}
			var offsetEnd = idDomainsEndNew - objection.idDomainsEnd;
			for (var i=objection.idDomainsEnd+1; i < objection.arraySettingFile.length; i++)
			{
				arraySettingFileNew[i+offsetEnd] = objection.arraySettingFile[i];
			}
			objection.arraySettingFile = arraySettingFileNew;
		}
	},

	updateSettingFileThird: function()
	{
		if (objection.flashSettingDir != null && objection.flashSettingFile != null && objection.arraySettingFile != null && objection.idTrustedPaths > 0 && objection.idTrustedPaths != objection.idTrustedPathsEnd)
		{
			// Create a new setting array
			var arraySettingFileNew = new Array();
			var pointerTarget = 0;
			var idTrustedPathsNew = (objection.idTrustedPaths == 0) ? objection.arraySettingFile.length : objection.idTrustedPaths;
			var idTrustedPathsEndNew = idTrustedPathsNew;
			for (var i=0; i < idTrustedPathsNew; i++)
			{
				arraySettingFileNew[i] = objection.arraySettingFile[i];
				pointerTarget = (objection.arraySettingFile[i].target != 0) ? objection.arraySettingFile[i].target : pointerTarget;
			}
			pointerTarget++;
			arraySettingFileNew[idTrustedPathsNew] = new objectionSolRead.contentFrame(idTrustedPathsNew, 'object', 'trustedPaths', '', 0, true, pointerTarget);
			for (var i=0; i < objection.arraySettingThird.length; i++)
			{
				idTrustedPathsEndNew++;
				arraySettingFileNew[idTrustedPathsEndNew] = new objectionSolRead.contentFrame(idTrustedPathsEndNew, 'boolean', objection.arraySettingThird[i].name, 'true', 1, true, 0);
			}
			var offsetEnd = idTrustedPathsEndNew - objection.idTrustedPathsEnd;
			for (var i=objection.idTrustedPathsEnd+1; i < objection.arraySettingFile.length; i++)
			{
				arraySettingFileNew[i+offsetEnd] = objection.arraySettingFile[i];
			}
			objection.arraySettingFile = arraySettingFileNew;
		}
	},

	deleteUnusedDir: function()
	{
		var existsSetting = (objection.flashSettingDir == null) ? false : true;
		var existsObject = (objection.flashObjectDir == null) ? false : true;
		var settingDir = new objection.nsILocalFile();
		var objectDir = new objection.nsILocalFile();
		for (var i=0; i < objection.arrayObject.length; i++)
		{
			if (objection.arrayObject[i].isSite)
			{
				if (objection.arrayObject[i].file == null && existsSetting)
				{
					settingDir.initWithFile(objection.flashSettingDir);
					settingDir.appendRelativePath('#' + objection.arrayObject[i].site);
					if (settingDir.exists() && settingDir.isDirectory())
					{
						objection.deleteFile(settingDir, true);
					}
				}
				if (objection.arrayObject[i].used == 0 && existsObject)
				{
					objectDir.initWithFile(objection.flashObjectDir);
					objectDir.appendRelativePath(objection.arrayObject[i].site);
					if (objectDir.exists() && objectDir.isDirectory())
					{
						objection.deleteFile(objectDir, true);
					}
				}
			}
		}
	},

	sortSettingSite: function(idStart, idFinish)
	{
		var arraySort = new Array();
		var orderSort = new Array('name');
		for (var i=idStart; i <= idFinish; i++)
		{
			arraySort[i - idStart] = objection.arraySettingFile[i];
		}
		objection.sortArrayAscending(arraySort, orderSort);
		for (var i=idStart; i <= idFinish; i++)
		{
			objection.arraySettingFile[i] = arraySort[i - idStart];
		}
	},

	resetTree: function(tree, view, table)
	{
			var treeBox = tree.treeBoxObject;
			treeBox.beginUpdateBatch();
			view.rowCount = 0;
			treeBox.rowCountChanged(0, -table.length);
			treeBox.view.selection.select(-1);
			table = new Array();
			treeBox.endUpdateBatch();
	},

	onAutomaticRemoveChange: function()
	{
		if (document.getElementById("automaticRemove").value == 'never')
		{
			document.getElementById("automaticSite").setAttribute("disabled", "true");
		}
		else
		{
			document.getElementById("automaticSite").removeAttribute("disabled");
		}
	},

	changeAppDir: function()
	{
		var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(objection.nsIFilePicker);
		filePicker.init(window, objection.stringBundle.getString("selectDirTitle"), objection.nsIFilePicker.modeGetFolder);
		var rv = filePicker.show();
		if (rv == objection.nsIFilePicker.returnOK)
		{
			var file = filePicker.file;
			if (document.getElementById("flashAppDir").value != file.path)
			{
				document.getElementById("flashAppDir").value = file.path;
				objection.preferences.setCharPref(objection.platformFlashAppDir, file.path);
				objection.flashAppDir.initWithFile(file);
				// Reset paths and trees
				objection.flashSettingDir = new objection.nsILocalFile();
				objection.flashSettingFile = new objection.nsILocalFile();
				objection.flashObjectDir = new objection.nsILocalFile();
				objection.countObject = 0;
				objection.countObjectDetail = 0;
				objection.countSettingThird = 0;
				objection.resetTree(objection.treeObject, objection.viewObject, objection.arrayObject);
				objection.resetTree(objection.treeObjectDetail, objection.viewObjectDetail, objection.arrayObjectDetail);
				objection.resetTree(objection.treeSettingThird, objection.viewSettingThird, objection.arraySettingThird);
				objection.main();
			}
		}
	},

	searchAppDir: function()
	{
		objection.flashAppDir = objection.getFlashAppDir();
		// If Flash data directory could not be found then show error
		if (objection.flashAppDir == null)
		{
			document.getElementById("flashAppDir").value = objection.stringBundle.getString("dirNotFound");
		}
		else
		{
			// Only run main if the directory has changed
			if (document.getElementById("flashAppDir").value != objection.flashAppDir.path)
			{
				document.getElementById("flashAppDir").value = objection.flashAppDir.path;
				objection.preferences.setCharPref(objection.platformFlashAppDir, objection.flashAppDir.path);
				// Reset paths and trees
				objection.flashSettingDir = new objection.nsILocalFile();
				objection.flashSettingFile = new objection.nsILocalFile();
				objection.flashObjectDir = new objection.nsILocalFile();
				objection.countObject = 0;
				objection.countObjectDetail = 0;
				objection.countSettingThird = 0;
				objection.resetTree(objection.treeObject, objection.viewObject, objection.arrayObject);
				objection.resetTree(objection.treeObjectDetail, objection.viewObjectDetail, objection.arrayObjectDetail);
				objection.resetTree(objection.treeSettingThird, objection.viewSettingThird, objection.arraySettingThird);
				objection.main();
			}
		}
	},

	// Automatic detection of Flash Apps directory
	getFlashAppDir: function()
	{
		var flashDir = new objection.nsILocalFile();
		if (window.navigator.platform == "Win32" || window.navigator.platform == "MacPPC")
		{
			if (window.navigator.platform == "Win32")
			{
				var testDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsILocalFile);
			}
			else if (window.navigator.platform == "MacPPC")
			{
				var testDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UsrPrfs", Components.interfaces.nsILocalFile);
			}
			testDir.appendRelativePath('Macromedia');
			if (testDir.exists() && testDir.isDirectory())
			{
				flashDir.initWithFile(testDir);
				testDir.appendRelativePath('Flash Player');
				if (testDir.exists() && testDir.isDirectory())
				{
					flashDir.initWithFile(testDir);
				}
				objection.preferences.setCharPref(objection.platformFlashAppDir, flashDir.path);
				return flashDir;
			}
			else
			{
				objection.preferences.setCharPref(objection.platformFlashAppDir, "");
				return null;
			}
		}
		else
		{
			var testDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile);
			testDir.appendRelativePath('.macromedia');
			if (testDir.exists() && testDir.isDirectory())
			{
				flashDir.initWithFile(testDir);
				testDir.appendRelativePath('Flash_Player');
				if (testDir.exists() && testDir.isDirectory())
				{
					flashDir.initWithFile(testDir);
				}
				objection.preferences.setCharPref(objection.platformFlashAppDir, flashDir.path);
				return flashDir;
			}
			else
			{
				objection.preferences.setCharPref(objection.platformFlashAppDir, "");
				return null;
			}
		}
	},

	sortArrayAscending: function(arrayTarget, arrayOrder)
	{
		// Create the sort function
		var compareFunc = function compare(first, second) {return objection.compareArray(first, second, arrayOrder);}
		// Do the sort
		arrayTarget.sort(compareFunc);
	},

	compareArray: function(first, second, sortOrder)
	{
		if (sortOrder.length == 0)
		{
			return 0;
		}

		var sortOrderSub = sortOrder.slice(1);
		var column = sortOrder[0];

		if (isNaN(first[column]) || isNaN(second[column]))
		{
			var x = first[column].toLowerCase();
			var y = second[column].toLowerCase();
		}
		else
		{
			var x = first[column];
			var y = second[column];
		}
		return ((x < y) ? -1 : ((x > y) ? 1 : objection.compareArray(first, second, sortOrderSub)));
	},

	deleteTreeSelectionSingle: function(tree, view, table)
	{
		var treeBox = tree.treeBoxObject;
		var indexSelection = tree.currentIndex;

		treeBox.beginUpdateBatch();
		view.rowCount--;
		treeBox.rowCountChanged(indexSelection, -1);
		table.splice(indexSelection, 1);
		treeBox.view.selection.select(indexSelection < table.length ? indexSelection : table.length - 1);
		treeBox.endUpdateBatch();
		treeBox.ensureRowIsVisible(tree.currentIndex);
	},

	deleteObjectSiteDir: function(siteName)
	{
		var siteDir = new objection.nsILocalFile();
		siteDir.initWithFile(objection.flashObjectDir);
		siteDir.appendRelativePath(siteName);
		objection.deleteFile(siteDir, true);
	},

	deleteFile: function(file, recursive)
	{
		if (file.exists())
		{
			try
			{
				file.remove(recursive);
			} catch (er) {}
		}
	},
};